unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, mmsystem, ComCtrls, XPMan;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    StatusBar1: TStatusBar;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    SpeedButton22: TSpeedButton;
    SpeedButton23: TSpeedButton;
    SpeedButton24: TSpeedButton;
    SpeedButton25: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton31: TSpeedButton;
    SpeedButton32: TSpeedButton;
    SpeedButton33: TSpeedButton;
    SpeedButton34: TSpeedButton;
    SpeedButton35: TSpeedButton;
    SpeedButton36: TSpeedButton;
    SpeedButton37: TSpeedButton;
    SpeedButton38: TSpeedButton;
    SpeedButton39: TSpeedButton;
    SpeedButton40: TSpeedButton;
    SpeedButton41: TSpeedButton;
    SpeedButton42: TSpeedButton;
    SpeedButton43: TSpeedButton;
    SpeedButton44: TSpeedButton;
    SpeedButton45: TSpeedButton;
    SpeedButton46: TSpeedButton;
    SpeedButton47: TSpeedButton;
    SpeedButton48: TSpeedButton;
    SpeedButton49: TSpeedButton;
    SpeedButton50: TSpeedButton;
    SpeedButton51: TSpeedButton;
    SpeedButton52: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SpeedButton52Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private-Deklarationen }
    Sound: Boolean;
    MoneyBag: array[1..26] of Byte;
    MoneyButton: array[1..26] of TSpeedButton;
    BagButton: array[1..26] of TSpeedButton;
    function CalcBank: LongWord;
    function BagCount: Byte;
  public
    { Public-Deklarationen }
    procedure PlaySnd(pszSound: PAnsiChar; fdwSound: Cardinal);
  end;

var
  Form1: TForm1;

implementation

uses UHighscore;

{$R *.dfm}
{$R Sound.res}

const
  MONEY: array[1..26] of Single = (0.01, 0.20, 0.50, 1, 5, 10, 20, 50, 100, 200, 300, 400, 500,
                                   1000, 2500, 5000, 7500, 10000, 12500, 15000, 20000, 25000,
                                   50000, 100000, 150000, 250000);

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  Randomize;
  for i:=1 to 26 do begin
    MoneyBag[i]:=i;
    MoneyButton[i]:=TSpeedButton(FindComponent('SpeedButton'+IntToStr(i)));
    BagButton[i]:=TSpeedButton(FindComponent('SpeedButton'+IntToStr(i+26)));
  end;
  Sound:=True;
end;

function TForm1.BagCount: Byte;
var i: Integer;
begin
  Result:=0;
  for i:=1 to 26 do
    if MoneyButton[i].Enabled then
      Inc(Result);
end;

procedure TForm1.Button1Click(Sender: TObject);
var i: Integer; a, b, c: Byte;
begin
  Image1.Visible:=False;
  Label1.Caption:='-';
  Label2.Caption:='-';
  for i:=1 to 26 do begin
    MoneyButton[i].Enabled:=True;
    BagButton[i].Visible:=True;
  end;
  GroupBox4.Enabled:=True;
  GroupBox5.Visible:=False;
  GroupBox8.Visible:=True;
  // Koffer mischen
  for i:=1 to 50000 do begin
    a:=Random(26)+1;
    b:=Random(26)+1;
    c:=MoneyBag[b];
    MoneyBag[b]:=MoneyBag[a];
    MoneyBag[a]:=c;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i: Integer;
begin
  // DEAL
  Form2.NewScore:=StrToFloat(Label1.Caption);
  Form2.ShowModal;
  GroupBox4.Enabled:=False;
  GroupBox6.Visible:=False;
  GroupBox5.Visible:=True;
  for i:=1 to 26 do
    if BagButton[i].Visible then begin
      BagButton[i].Visible:=False;
      MoneyButton[MoneyBag[BagButton[i].Tag]].Enabled:=False;
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  // NO DEAL
  GroupBox4.Enabled:=True;
  GroupBox6.Visible:=False;
  GroupBox7.Visible:=True;
  Label1.Caption:='-';
end;

function Tform1.CalcBank: Longword;
var
  l,h: Single;
  i: integer;
  lowsum, highsum: Single;
begin
  lowsum:=0;
  highsum:=0;
  for i:=1 to 26 do
    if MoneyButton[i].Enabled then
      if MONEY[i]<1000 then
        lowsum:=lowsum+MONEY[i]
      else
        highsum:=highsum+MONEY[i];
  l:=0; h:=0;
  case Bagcount of
     20: begin l:=0.07; h:=0.11; end;
     15: begin l:=0.09; h:=0.16; end;
     11: begin l:=0.13; h:=0.21; end;
      8: begin l:=0.17; h:=0.26; end;
      6: begin l:=0.20; h:=0.31; end;
      5: begin l:=0.33; h:=0.32; end;
   1..4: begin l:=0.5; h:=0.32+(5-bagcount)*0.01; end;
  end;
  Result:=Round(lowsum*l+highsum*l*h);
end;

procedure TForm1.SpeedButton52Click(Sender: TObject);
var sb: TSpeedButton; Bags: Byte;
begin
  PlaySnd('SND_CLICK', SND_RESOURCE or SND_ASYNC);
  sb:=TSpeedButton(Sender);
  sb.Visible:=False;
  if Label2.Caption='-' then begin
    Label2.Caption:=IntToStr(sb.Tag);
    GroupBox8.Visible:=False;
    GroupBox7.Visible:=True;
    Image1.Visible:=True;
  end else begin
    MoneyButton[MoneyBag[sb.Tag]].Enabled:=False;
    if MoneyBag[sb.Tag]=26 then
      PlaySnd('SND_ARGH', SND_RESOURCE or SND_SYNC);
    if BagCount=1 then begin
      Form2.NewScore:=MONEY[MoneyBag[StrToInt(Label2.Caption)]];
      Form2.ShowModal;
      GroupBox7.Visible:=False;
      GroupBox5.Visible:=True;
    end else
      if (BagCount=20) or (BagCount=15) or (BagCount=11) or (BagCount=8) or (BagCount<=6) then begin
        GroupBox4.Enabled:=False;
        GroupBox7.Visible:=False;
        GroupBox6.Visible:=True;
        PlaySnd('SND_RINGIN', SND_RESOURCE or SND_ASYNC);
        Label1.Caption:=IntToStr(CalcBank);
      end;
  end;
  // Kofferanzahl bis zum nchsten Bankangebot berechnen
  Bags:=0;
  case BagCount of
    21..26: Bags:=BagCount-20;
    16..20: Bags:=BagCount-15;
    12..15: Bags:=BagCount-11;
    09..11: Bags:=BagCount-8;
    07..08: Bags:=BagCount-6;
    01..06: Bags:=1;
  end;
  if BagCount>2 then
    StatusBar1.Panels[0].Text:='Noch '+IntToStr(Bags)+' Koffer bis zum nchsten Bankangebot!'
  else
    StatusBar1.Panels[0].Text:='';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.PlaySnd(pszSound: PAnsiChar; fdwSound: Cardinal);
begin
  if Sound then
    PlaySound(pszSound, HInstance, fdwSound);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key=VK_F8 then begin
    Sound:=not Sound;
    if Sound then
      StatusBar1.Panels[1].Text:='[F8] Sound AUS'
    else
      StatusBar1.Panels[1].Text:='[F8] Sound AN';
  end;
end;

end.
